package com.nisum.offertransactionservice.client;


import com.safeway.epe.model.Employee;
import org.junit.Before;
import org.junit.Test;
import org.junit.runner.RunWith;
import org.mockito.InjectMocks;
import org.mockito.Mock;
import org.mockito.MockitoAnnotations;
import org.mockito.junit.MockitoJUnitRunner;
import org.springframework.test.util.ReflectionTestUtils;
import org.springframework.test.web.reactive.server.WebTestClient;
import org.springframework.web.reactive.function.client.WebClient;
import reactor.core.publisher.Mono;

import static org.mockito.Mockito.when;

@RunWith(MockitoJUnitRunner.class)
public class ClientServiceTest {


    @Mock
    WebTestClient webTestClient;


    @Before
    public void setUp() throws Exception {
        MockitoAnnotations.initMocks(this);
    }


    @Mock
    private WebClient webClientMock;
    @Mock
    private WebClient.RequestHeadersSpec requestHeadersMock;
    @Mock
    private WebClient.RequestHeadersUriSpec requestHeadersUriMock;
    @Mock
    private WebClient.RequestBodySpec requestBodyMock;
    @Mock
    private WebClient.RequestBodyUriSpec requestBodyUriMock;
    @Mock
    private WebClient.ResponseSpec responseMock;



    @InjectMocks
    ClientService clientService;


    @Test
    public void getStringMonoTest(){
        String uuid = "86fd4146-0540-405b-b621-a95f4ccdfa0d";

        ReflectionTestUtils.setField(clientService,"storeConsumerUrl","/store/producer");
//        when(webClientMock.post()).thenReturn(requestBodyUriMock);
//        when(requestHeadersUriMock.uri("/store/producer")).thenReturn(requestHeadersMock);
//        when(requestHeadersMock.retrieve()).thenReturn(responseMock);
//        when(responseMock.bodyToMono(String.class)).thenReturn(Mono.just(uuid));


        when(webClientMock.post()).thenReturn(requestBodyUriMock);
        when(requestBodyUriMock.uri("/store/producer")).thenReturn(requestBodyMock);
        when(requestBodyMock.bodyValue(Mono.just(uuid))).thenReturn(requestHeadersMock);
        when(requestHeadersMock.retrieve()).thenReturn(responseMock);
        when(responseMock.bodyToMono(String.class)).thenReturn(Mono.just(uuid));




        Mono<String> employeeMono = clientService.getStringMono(uuid);


    }








}
